class ['a] pair (e1_p : 'a) (e2_p : 'a) =
object (self : 'b)
  val mutable e1 = e1_p
  val mutable e2 = e2_p
  method first = e1
  method second = e2
  method private set_first e1_new = e1 <- e1_new
  method private set_second e2_new = e2 <- e2_new
  method eq (p : 'b) = p#first = self#first && p#second = self#second
end;;

exception Invalid_scalar;;

class vector x_p y_p =
object (self)
  inherit [int] pair x_p y_p
  method x = e1
  method y = e2
  method scale s =
    if (s = infinity) || (s = neg_infinity) || (s = nan)
    then raise Invalid_scalar
    else self#set_first (int_of_float (float_of_int e1 *. s));
         self#set_second (int_of_float (float_of_int e2 *. s))
end;;

class point x_p y_p =
object (self)
  inherit [int] pair x_p y_p
  method x = self#first
  method y = self#second
  method move (v : vector) =
    self#set_first (self#first + v#first);
    self#set_second (self#second + v#second)
end;;

(**** TESTS ****
let v = new vector 1 2;;
v#x;;
v#y;;
try
  v#scale infinity
with Invalid_scalar -> print_endline "Scaling by an invalid scalar.";;
v#x;;
v#y;;
v#scale 3.;;
v#x;;
v#y;;
v#scale 0.7;;
v#x;;
v#y;;
let p = new point 7 3;;
p;;
p#x;;
p#y;;
p#move (new vector 1 (-42));;
p#x;;
p#y;;
*)
